variables:
  IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG

workflow:
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
    - if: "$CI_COMMIT_BRANCH && $CI_OPEN_MERGE_REQUESTS"
      when: never
    - if: "$CI_COMMIT_BRANCH"

stages:
  - build
  - deploy
  - release

.registry_login:
  image: docker:24.0.5
  services:
    - docker:24.0.5-dind
  before_script:
    - export TZ=Asia/Seoul
    - ln -snf /usr/share/zoneinfo/$TZ /etc/localtime && echo $TZ > /etc/timezone
    - apk update && apk add unzip curl aws-cli git
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

build:
  rules:
    - when: on_success
  stage: build
  extends: .registry_login
  script:
    - docker build -t test .

publish:
  stage: deploy
  extends: .registry_login
  rules:
    - if: "$CI_DEFAULT_BRANCH == $CI_COMMIT_BRANCH"
  script:
    - docker build --progress=plain -t $IMAGE_TAG .
    - docker push $IMAGE_TAG

release:
  rules:
    - if: "$CI_DEFAULT_BRANCH == $CI_COMMIT_BRANCH"
      when: manual
  stage: release
  extends: .registry_login
  script:
    - docker pull $IMAGE_TAG
    - docker tag $IMAGE_TAG $CI_REGISTRY_IMAGE:latest
    - docker tag $IMAGE_TAG $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
    - docker push $CI_REGISTRY_IMAGE:latest
